# -------------------------- Import ------------------------------ #
import os
import time
from upemtk import *
from random import *
from ast import *

# ------------------------- Fonctions ---------------------------- #

# ----------- Menu du jeu ------------ #

def affichageMenu():
	"""
	Créée le menu avec du texte et des rectangles servant de "boutons"
	"""
	global choix, xy1_Jouer, xy1_Load, xy2_Load, xy2_Jouer, xy1_affichageRegles, xy2_affichageRegles, xy1_Close, xy2_Close
	## Titre du jeu ##
	efface_tout()
	image(largeur*nbCasesX/2+180, 10, 'titreJeu.gif', ancrage="n")

	texte(largeur*nbCasesX/2+180, largeur*4, "Bienvenue aventurier!", couleur="black", taille=30, ancrage="n")
	texte(largeur*nbCasesX/2+180, largeur*5, "Que souhaitez-vous faire?", couleur="black", taille=30, ancrage="n")
	## Cadre ##
	rectangle(largeur*2, largeur*3.5, (nbCasesX*largeur)+250, (nbCasesY*largeur+75)-(largeur*2), epaisseur = 3, couleur = 'red')
	## Bouton jouer ##
	rectangle(largeur*nbCasesX/2-190, largeur*7, largeur*nbCasesX/2+80, largeur*9, remplissage="green", tag = 'startButton')
	texte(largeur*nbCasesX/2-55, largeur*7.6, "Jouer", couleur="white", taille=25, ancrage="n", tag = 'start')
	xy1_Jouer = largeur*nbCasesX/2-190, largeur*7
	xy2_Jouer = largeur*nbCasesX/2+80, largeur*9
	## Bouton continuer ##
	rectangle(largeur*nbCasesX/2+280, largeur*7, largeur*nbCasesX/2+550, largeur*9, remplissage="orange", tag = 'loadButton')
	texte(largeur*nbCasesX/2+415, largeur*7.6, "Continuer", couleur="white", ancrage="n", tag = 'load')
	xy1_Load = largeur*nbCasesX/2+280, largeur*7
	xy2_Load = largeur*nbCasesX/2+550, largeur*9
	## Bouton quitter ##
	rectangle(largeur*nbCasesX/2-190, largeur*10, largeur*nbCasesX/2+80, largeur*12, remplissage="darkred", tag = 'closeButton')
	texte(largeur*nbCasesX/2-55, largeur*10.6, "Quitter", couleur="white", ancrage="n", tag = 'close')
	xy1_Close = largeur*nbCasesX/2-190, largeur*10
	xy2_Close = largeur*nbCasesX/2+80, largeur*12
	## Bouton règles ##
	rectangle(largeur*nbCasesX/2+280, largeur*10, largeur*nbCasesX/2+550, largeur*12, remplissage="darkblue", tag = 'affichageReglesButton')
	texte(largeur*nbCasesX/2+415, largeur*10.6, "Règles", couleur="white", ancrage="n", tag = 'affichageRegles')
	xy1_affichageRegles = largeur*nbCasesX/2+280, largeur*10
	xy2_affichageRegles = largeur*nbCasesX/2+550, largeur*12

	## On regarde sur quel bouton le joueur à appuyer ##
	choix = choixMenu()
	if choix == 'Règles': affichageRegles()
	if choix == 'Continuer': continuer()
	if choix == 'Jouer': affichageJoueurs()

def affichageJoueurs():
	"""
	Affiche 3 boutons permettant au joueur de choisir si il veut jouer à 1, 2 ou 3 joueurs.
	"""
	global nbrJoueurs, xy1_1j, xy2_1j, xy1_2j, xy2_2j, xy1_3j, xy2_3j
	## Titre du jeu ##
	efface_tout()
	image(largeur*nbCasesX/2+180, 10, 'titreJeu.gif', ancrage="n")

	texte(largeur*nbCasesX/2+180, largeur*4, "Choisissez un mode de joueur", couleur="black", taille=30, ancrage="n")
	## Cadre ##
	rectangle(largeur*2, largeur*3.5, (nbCasesX*largeur)+250, (nbCasesY*largeur+75)-(largeur*2), epaisseur = 3, couleur = 'red')
	## Bouton 1 joueur ##
	rectangle(largeur*nbCasesX/2-190, largeur*7, largeur*nbCasesX/2+80, largeur*9, remplissage="darkred", tag = 'bouton1J')
	texte(largeur*nbCasesX/2-55, largeur*7.6, "1 joueur", couleur="white", taille=25, ancrage="n", tag = 'texte1J')
	xy1_1j = largeur*nbCasesX/2-190, largeur*7
	xy2_1j = largeur*nbCasesX/2+80, largeur*9
	## Bouton 2 joueurs ##
	rectangle(largeur*nbCasesX/2+280, largeur*7, largeur*nbCasesX/2+550, largeur*9, remplissage="darkblue", tag = 'bouton2J')
	texte(largeur*nbCasesX/2+415, largeur*7.6, "2 joueurs", couleur="white", ancrage="n", tag = 'texte2J')
	xy1_2j = largeur*nbCasesX/2+280, largeur*7
	xy2_2j = largeur*nbCasesX/2+550, largeur*9
	## Bouton 3 joueurs ##
	rectangle(largeur*nbCasesX/2+55, largeur*10, largeur*nbCasesX/2+315, largeur*12, remplissage="orange", tag = 'bouton3J')
	texte(largeur*nbCasesX/2+190, largeur*10.6, "3 joueurs", couleur="white", ancrage="n", tag = 'texte3J')
	xy1_3j = largeur*nbCasesX/2+55, largeur*10
	xy2_3j = largeur*nbCasesX/2+315, largeur*12

	nbrJoueurs = choixJoueur()
	efface('cadreMenu')
	if nbrJoueurs == '1 joueur':
		return '1j'
	if nbrJoueurs == '2 joueurs':
		return '2j'
	if nbrJoueurs == '3 joueurs':
		return '3j'

def affichageRegles():
	"""
	Affiche les règles du jeu
	"""
	efface_tout()
	## Texte règles ##
	texte(5, 25, "Règles du jeu:", couleur="red", ancrage="w")
	texte(5, 95, "Le jeu se compose de 4 personnages, de 4 objets et d'une porte de sortie. ",couleur='black', ancrage='w', taille=12 )
	texte(5, 130, "Vous pouvez controler les 4 personnages mais uniquement un à la fois. Chaque personnage possède son propre objet.", couleur='black', ancrage='w', taille=12)
	texte(5, 200, "Le but est de récupérer tous les objets puis de sortir.", couleur='black', ancrage='w', taille=12)
	texte(5, 235, "Au départ, la porte de sortie est vérouillée. Pour permettre son ouverture, chaque personnage doit se trouver sur la case de l'objet lui correspondant,", couleur='black', ancrage='w', taille=12)
	texte(5, 270, "cela revient à récupérer tous les objets Le mage possède la fiole, l'elfe possède l'arc, le nain possède la hache et le barbare possède l'épée.", couleur='black', ancrage='w', taille=12)
	texte(5, 335,"ATTENTION, vous disposez d'un temps limité de 3mn. Si vous le dépassez c'est GAME OVER.", couleur='red', ancrage='w',taille=15)
	texte(5, 390,"Si vous êtes proche de la fin du temps imparti, n'hésitez pas à récupérer des sabliers ! Ils permettent d'inverser le temps.", couleur='black', ancrage='w', taille=12)
	texte(5, 425,"Mais attention à ne pas les récupérer si il vous reste beaucoup de temps, ou vous vous retrouverez à devoir courrir!", couleur='black', ancrage='w', taille=12)
	texte(5, 460, "Pour le vortex, appuyez sur la touche 8 du pavé numérique pour changer de vortex séléctionné.", couleur='black', ancrage='w',taille=15)
	texte(85, 535,"MAINTENANT QUE VOUS SAVEZ TOUT, BONNE CHANCE JEUNES VOLEURS !!", couleur='dark blue', ancrage='w',taille=18)
	## Bouton retour ##
	rectangle(largeur*nbCasesX, largeur/2, largeur*nbCasesX +largeur*3, largeur*1.5, remplissage = 'black')
	texte(largeur*nbCasesX +25, largeur, 'Retour', couleur = 'white', ancrage = 'w')
	coordClic = attente_clic()
	if coordClic[0] > largeur*nbCasesX and coordClic[0] < largeur*nbCasesX +largeur*3:
		if coordClic[1] > largeur/2 and coordClic[1] < largeur*1.5: affichageMenu()
		else: affichageRegles()
	else: affichageRegles()

def choixMenu():
	"""
	Compare les coordonnées du clic aux coordonnées des rectangles du menus.
	On effectue une action différente en fonction du bouton cliqué par le joueur.
	"""
	coordClic = attente_clic()
	## Actionner bouton jouer ##
	if coordClic[0] > xy1_Jouer[0] and coordClic[0] < xy2_Jouer[0]:
		if coordClic[1] > xy1_Jouer[1] and coordClic[1] < xy2_Jouer[1]:
			return 'Jouer'
	## Actionner bouton continuer ##
	if coordClic[0] > xy1_Load[0] and coordClic[0] < xy2_Load[0]:
		if coordClic[1] > xy1_Load[1] and coordClic[1] < xy2_Load[1]:
			return 'Continuer'
	## Actionner bouton quitter ##
	if coordClic[0] > xy1_Close[0] and coordClic[0] < xy2_Close[0]:
		if coordClic[1] > xy1_Close[1] and coordClic[1] < xy2_Close[1]:
			return 'Quitter'
	## Actionner bouton règles ##
	if coordClic[0] > xy1_affichageRegles[0] and coordClic[0] < xy2_affichageRegles[0]:
		if coordClic[1] > xy1_affichageRegles[1] and coordClic[1] < xy2_affichageRegles[1]:
			return 'Règles'
		else:					# Si on clique ailleur dans la fenêtre, on reste sur le menu.
			affichageMenu()
	else:
		affichageMenu()

def choixJoueur():
	"""
	Compare les coordonnées du clic aux coordonnées des rectangles du menus.
	On lance le jeu avec le mode de joueur séléctionné.
	"""
	coordClic = attente_clic()
	## Actionner bouton 1 joueur ##
	if coordClic[0] > xy1_1j[0] and coordClic[0] < xy2_1j[0]:
		if coordClic[1] > xy1_1j[1] and coordClic[1] < xy2_1j[1]:
			return '1 joueur'
	## Actionner bouton 2 joueurs ##
	if coordClic[0] > xy1_2j[0] and coordClic[0] < xy2_2j[0]:
		if coordClic[1] > xy1_2j[1] and coordClic[1] < xy2_2j[1]:
			return '2 joueurs'
	## Actionner bouton 3 joueurs ##
	if coordClic[0] > xy1_3j[0] and coordClic[0] < xy2_3j[0]:
		if coordClic[1] > xy1_3j[1] and coordClic[1] < xy2_3j[1]:
			return '3 joueurs'
		else:					# Si on clique ailleur dans la fenêtre, on reste sur la page actuelle.
			choixJoueur()
	else:
		choixJoueur()

# ---------- Partie Logique ---------- #

# --- Création entités --- #

def creationMap(l, L) :
	"""
	Créer une fenêtre avec un nombre de cases en X et Y donné.
	Créer une matrice remplie de 0
	"""
	global nbCasesX, nbCasesY, largeur, Plateau 
	largeur, nbCasesX, nbCasesY, Plateau = 50, l, L, list()
	Plateau = [[0 for j in range(nbCasesX)] for i in range(nbCasesY)]
	cree_fenetre((nbCasesX*largeur+350), (nbCasesY*largeur + 75))	# Création de la fenêtre

def getTuiles(fichier):
	with open(fichier, 'r') as fic_tuiles:
		copy=str()
		for ligne in fic_tuiles : copy += ligne
		copy = copy.split('$')
	total_tuiles = list()
	for i in range(0,len(copy),12):
		total_tuiles.append(literal_eval(copy[i]))
	return total_tuiles

def getPosObjet(objets,ObjWar,ObjWiz,ObjElf,ObjDwa):
	'''
	Remplit la variable qui contient la position de chaque objet, quand un nouveau est découvert.
	'''
	idObjets = [11,12,13,14]
	obj = ['ObjWar','ObjWiz','ObjElf','ObjDwa']
	for yAxes in range(nbCasesY):
		for xAxes in range(nbCasesX):
			if Plateau[yAxes][xAxes] == idObjets[0]: ObjWar=(yAxes,xAxes)
			if Plateau[yAxes][xAxes] == idObjets[1]: ObjWiz=(yAxes,xAxes)
			if Plateau[yAxes][xAxes] == idObjets[2]: ObjElf=(yAxes,xAxes)
			if Plateau[yAxes][xAxes] == idObjets[3]: ObjDwa=(yAxes,xAxes)
	objetVu = [ObjWar,ObjWiz,ObjElf,ObjDwa]
	return objetVu,ObjWar,ObjWiz,ObjElf,ObjDwa

def getMurs(fichier,nTuile, listeMurH, listeMurV, decalX, decalY):
	'''
	Remplit la variable qui contient les positions des murs a chaque fois qu'une tuile est rajoutée.
	'''
	with open(fichier, 'r') as fic_tuiles:
		copy=str()
		for ligne in fic_tuiles : copy += ligne
		tuile = copy.split('$')
	murs = list()
	# Ajout des murs a leurs variables
	for x in range(2):
		murs.append([literal_eval(tuile[nTuile*12+1+x])])
		for i in range(len(murs[x][0])):
			lst = list(murs[x][0][i])
			lst[0] += decalX 			# Décale la position donné de X cases
			lst[1] += decalY 			# Décale la position donné de Y cases
			if x == 0 : listeMurH.append(tuple(lst))			# Ajoute la nouvelle position à la liste des murs
			if x == 1 : listeMurV.append(tuple(lst))
	return listeMurH, listeMurV

def getExploration(fichier,nTuile, listeExploWar, listeExploWiz, listeExploElf, listeExploDwa, decalX, decalY):
	'''
	Remplit la variable qui contient les positions des explorations a chaque fois qu'une tuile est rajoutée.
	'''
	with open(fichier, 'r') as fic_tuiles:
		copy=str()
		for ligne in fic_tuiles : copy += ligne
		tuile = copy.split('$')
	explorations = list()
	# Ajout des explorations
	for x in range(4):
		explorations.append([literal_eval(tuile[nTuile*12+3+x])])
		for i in range(len(explorations[x][0])):
			lst = list(explorations[x][0][i])
			lst[0] += decalX 			# Décale la position donné de X cases
			lst[1] += decalY 			# Décale la position donné de Y cases
			if x == 0 : listeExploWar.append(tuple(lst))			# Ajoute la nouvelle position à la liste des explorations
			if x == 1 : listeExploWiz.append(tuple(lst))
			if x == 2 : listeExploElf.append(tuple(lst))
			if x == 3 : listeExploDwa.append(tuple(lst))

	return listeExploWar, listeExploWiz, listeExploElf, listeExploDwa

def getVortex(fichier,nTuile, listeVortexWar, listeVortexWiz, listeVortexElf, listeVortexDwa, decalX, decalY):
	'''
	Remplit la variable qui contient les positions des vortex a chaque fois qu'une tuile est rajoutée.
	'''
	with open(fichier, 'r') as fic_tuiles:
		copy=str()
		for ligne in fic_tuiles : copy += ligne
		tuile = copy.split('$')
	vortex = list()
	# Ajout des vortex
	for x in range(4):
		vortex.append([literal_eval(tuile[nTuile*12+7+x])])
		for i in range(len(vortex[x][0])):
			lst = list(vortex[x][0][i])
			lst[0] += decalX 			# Décale la position donné de X cases
			lst[1] += decalY 			# Décale la position donné de Y cases
			if lst[0] < 50 and lst[1] < 50:
				if x == 0 : listeVortexWar.append(tuple(lst))			# Ajoute la nouvelle position à la liste des vortex
				if x == 1 : listeVortexWiz.append(tuple(lst))
				if x == 2 : listeVortexElf.append(tuple(lst))
				if x == 3 : listeVortexDwa.append(tuple(lst))
	return listeVortexWar, listeVortexWiz, listeVortexElf, listeVortexDwa

def getEscalator(fichier,nTuile, listeEscalators, decalX, decalY):
	'''
	Remplit la variable qui contient les escalators a chaque fois qu'une tuile est rajoutée.
	'''
	with open(fichier, 'r') as fic_tuiles:
		copy=str()
		for ligne in fic_tuiles : copy += ligne
		tuile = copy.split('$')
	escalators = list()
	# Ajout des escalators
	escalators.append([literal_eval(tuile[nTuile*12+11])])
	for i in range(len(escalators[0][0])):
		lst = list(escalators[0][0][i])
		lst[0] += decalX 			# Décale la position donné de X cases
		lst[1] += decalY 			# Décale la position donné de Y cases
		listeEscalators.append(tuple(lst))			# Ajoute la nouvelle position à la liste des escalators
	return listeEscalators

# --- Actions --- #

def actions1J():
	global actionsJ1, actionsJ2, actionsJ3
	actionsJ1 = ['Left','Right','Up','Down','Vortex','Escalators', 'Exploration']
	actionsJ2, actionsJ3 = list('*'), list('*')

def actions2J():
	global actionsJ1, actionsJ2, actionsJ3
	actionsJ1, actionsJ2, actionsJ3 = list(), list(), list('*')

	directionAppliquee = 0
	while directionAppliquee != 2:
		rdmDirection = directions[randint(0,len(directions)-1)]
		if rdmDirection not in actionsJ2 :
			actionsJ2.append(rdmDirection)
			directionAppliquee += 1
	actionsJ2.append(special[randint(0,len(special)-1)])

	full = directions + special
	actionsJ1 = [i for i in full + actionsJ2 if i not in full or i not in actionsJ2]

def actions3J():
	global actionsJ1, actionsJ2, actionsJ3
	actionsJ1, actionsJ2, actionsJ3 = list(), list(), list()
	# Ajout des actions au J2
	actionsJ2.append(directions[randint(0,len(directions)-1)])
	actionsJ2.append(special[randint(0,len(special)-1)])
	# Ajout des actions au J3
	ajouter_dirJ3, ajouter_actJ3, ajouter_dirJ1, ajouter_actJ1 = 0,0,0,0
	while len(actionsJ1) != 3:
		rdmDirection = directions[randint(0,len(directions)-1)]
		rdmAction = special[randint(0,len(special)-1)]
		# Joueur 3
		if rdmDirection not in actionsJ2 and ajouter_dirJ3 < 1:
			actionsJ3.insert(0,rdmDirection)
			ajouter_dirJ3 += 1
		if rdmAction not in actionsJ2 and ajouter_actJ3 < 1:
			actionsJ3.append(rdmAction)
			ajouter_actJ3 += 1
		# Joueur 1
		if rdmDirection not in actionsJ1 and rdmDirection not in actionsJ2 and rdmDirection not in actionsJ3 and ajouter_dirJ1 < 2:
			actionsJ1.insert(0,rdmDirection)
			ajouter_dirJ1 += 1
		if rdmAction not in actionsJ2 and rdmAction not in actionsJ3 and rdmAction not in actionsJ1 and ajouter_actJ1 < 1:
			actionsJ1.append(rdmAction)
			ajouter_actJ1 += 1

def actionAimedJ1(actionChoisieJ1):
	"""
	Fonctionne avec la fonction actionSelectedJ1(i), qui permet de choisir l'action à effectuer pour le J1.
	Elle renvoie l'action séléctionnée.
	"""
	actionViséeJ1 = actionChoisieJ1+1
	if actionViséeJ1 > len(actionsJ1): actionViséeJ1 = 1
	return actionViséeJ1

def actionAimedJ2(actionChoisieJ2):
	"""
	Fonctionne avec la fonction actionSelectedJ2(i), qui permet de choisir l'action à effectuer pour le J2.
	Elle renvoie l'action séléctionnée.
	"""
	actionViséeJ2 = actionChoisieJ2+1
	if actionViséeJ2 > len(actionsJ2): actionViséeJ2 = 1
	return actionViséeJ2 

def actionAimedJ3(actionChoisieJ3):
	"""
	Fonctionne avec la fonction actionSelectedJ3(i), qui permet de choisir l'action à effectuer pour le J3.
	Elle renvoie l'action séléctionnée.
	"""
	actionViséeJ3 = actionChoisieJ3+1
	if actionViséeJ3 > len(actionsJ3): actionViséeJ3 = 1
	return actionViséeJ3

def pionAimed(pionChoisi):
	"""
	Fonctionne avec la fonction pionSelected(i), qui permet de choisir le pion à séléctionner.
	Elle renvoie le pion séléctionnée.
	"""
	pionVisé = pionChoisi+1
	if pionVisé > 4: pionVisé = 1
	return pionVisé

def vortexAimed(vortexChoisi):
	"""
	Choix du vortex sur lequel se téléporter.
	"""
	dico_VorPion = {1:posVortex_War, 2:posVortex_Wiz, 3:posVortex_Elf, 4:posVortex_Dwa}
	vortexVisé = vortexChoisi+1
	if vortexVisé > len(dico_VorPion.get(pionVisé))-1: vortexVisé = 0
	return vortexVisé

def isSortieOn(etatSortie):
	"""
	Active la sortie si tous les joueurs sont sur leur case objet.
	"""	
	global pionsSurObj
	if etatSortie == False :
		pionsSurObj = 0
		if (99,99) not in posObjets:
			for yAxes in range(nbCasesY):
				for xAxes in range(nbCasesX):
					# +1 si un pion est sur sa case objet.
					for i in range(4):
						if Plateau[yAxes][xAxes] == i+1:
							if yAxes == posObjets[i][0] and xAxes == posObjets[i][1]: pionsSurObj += 1
		# Si tous les pions sont sur leur case objet : sortie active
		pionsSurObj = 4
		if pionsSurObj == 4:
			for yAxes in range(nbCasesY):
				for xAxes in range(nbCasesX):
					if Plateau[yAxes][xAxes] == 5:
						Plateau[yAxes][xAxes] = 6
						return True
		return False
	return True

def isWin(pionsSortis):
	"""
	Si les 4 joueurs ont atteints la sortie, la partie s'arrête et on à gagner.
	"""
	if pionsSortis == 4:
		gagner()

def sauvegarder():
	to_save = [Plateau,actionsJ1,actionsJ2,actionsJ3,nbrJoueurs,pionsInSortie,pionsSurObj,
				posMurH,posMurV,posEscalator, posObjets, tuilesUsed,
				posExploration_War,posVortex_War, posObjWar,posExploration_Wiz, posVortex_Wiz, posObjWiz,
				posExploration_Elf, posVortex_Elf, posObjElf,posExploration_Dwa, posVortex_Dwa, posObjDwa,
				minutes,secondes,secElapsed,startTime]
	with open('save.txt', 'w') as fic_save:
		for elem in to_save: fic_save.write(str(elem)+'$')

def continuer():
	global Plateau,actionsJ1,actionsJ2,actionsJ3,nbrJoueurs,pionsInSortie,pionsSurObj,posMurH,posMurV,posEscalator,posObjets,tuilesUsed,posExploration_War,posVortex_War,posObjWar,posExploration_Wiz,posVortex_Wiz,posObjWiz,posExploration_Elf,posVortex_Elf,posObjElf,posExploration_Dwa,posVortex_Dwa,posObjDwa,minutes,secondes,secElapsed,startTime
	efface_tout()
	with open('save.txt', 'r') as fic_save:
		var = str()
		for ligne in fic_save : var += ligne
		var = var.split('$')
	Plateau,actionsJ1,actionsJ2,actionsJ3,nbrJoueurs = literal_eval(var[0]),literal_eval(var[1]),literal_eval(var[2]),literal_eval(var[3]),var[4]
	pionsInSortie, pionsSurObj = int(var[5]), int(var[6])
	posMurH,posMurV,posEscalator, posObjets, tuilesUsed = literal_eval(var[7]),literal_eval(var[8]),literal_eval(var[9]),literal_eval(var[10]),literal_eval(var[11])
	posExploration_War,posVortex_War, posObjWar,posExploration_Wiz, posVortex_Wiz, posObjWiz = literal_eval(var[12]),literal_eval(var[13]),literal_eval(var[14]),literal_eval(var[15]),literal_eval(var[16]),literal_eval(var[17])
	posExploration_Elf, posVortex_Elf, posObjElf,posExploration_Dwa, posVortex_Dwa, posObjDwa = literal_eval(var[18]),literal_eval(var[19]),literal_eval(var[20]),literal_eval(var[21]),literal_eval(var[22]),literal_eval(var[23])
	minutes, secondes, secElapsed, startTime = float(var[24]),float(var[25]),float(var[26]),float(var[27])
	if pionsSurObj+pionsInSortie == 4: sortieOn = True

def actionTouche(pion, actionJ1, actionJ2, actionJ3, choisirVortex, onIndiceExplo, objets, pionsSortis, debug, mursH, mursV, exploWar, exploWiz, exploElf, exploDwa, vortexWar, vortexWiz, vortexElf, vortexDwa, escalators):
	"""
	Gère les déplacements à faire selon chaque touche directionnelle appuyée.
	Selon la case sur laquelle veut aller un pion, l'action sera différente.
	"""
	global touche, pionVisé, actionViséeJ1, actionViséeJ2, actionViséeJ3, vortexVisé, pionsInSortie, reverseTimer, a, secElapsed
	touche = attente_touche_jusqua(1000)
	choixAction = ['Left', 'Right', 'Up', 'Down','Escalators','Exploration']
	choixPion = [1, 2, 3, 4]
	dico_VorPion = {1:vortexWar, 2:vortexWiz, 3:vortexElf, 4:vortexDwa}
	dico_ExploPion = {1:exploWar, 2:exploWiz, 3:exploElf, 4:exploDwa}
	posEscalator = escalators
	deplacement, dejaVu, ajouté, valide = None, False, False, False
	# F1 : Ferme la fenêtre()
	if touche == 'F1': ferme_fenetre()
	# F2 : Mode debug on/off
	if touche == 'F2': debug = not debug
	# F3 : Sauvegarder
	if touche == 'F3' : sauvegarder()
	#  e : change de pion à déplacer
	if touche == 'e' : 
		pionVisé = pionAimed(pionVisé)
		vortexVisé = 0
	# Change l'action séléctionnée pour le Joueur X
	if touche == '1' : 
		actionViséeJ1 = actionAimedJ1(actionViséeJ1)
		choisirVortex = False
	if touche == '2' : 
		actionViséeJ2 = actionAimedJ2(actionViséeJ2)
		choisirVortex = False
	if touche == '3' : 
		actionViséeJ3 = actionAimedJ3(actionViséeJ3)
		choisirVortex = False
	# Déplace le pion avec l'action séléctionnée pour le Joueur X
	if touche == '4' : deplacement = actionsJ1[actionJ1-1]
	if touche == '5' : deplacement = actionsJ2[actionJ2-1]
	if touche == '6' : deplacement = actionsJ3[actionJ3-1]
	# Déplacements et actions aléatoire si le mode debug est ON
	if debug == True : deplacement, pion, touche = choixAction[randint(0,5)], choixPion[randint(0,3)], 'F2'
	# Choix du vortex sur lequel se téléporter
	if choisirVortex == True:
		if touche == '8' : vortexVisé = vortexAimed(vortexVisé)
		if touche == '4' :
			choisirVortex = False
			for i in range(4):
				for yAxes in range(nbCasesY):
					for xAxes in range(nbCasesX):
						if Plateau[yAxes][xAxes] == pion and pion == i+1:
							Plateau[yAxes][xAxes],Plateau[(dico_VorPion.get(i+1)[vortexVisé][0])][dico_VorPion.get(i+1)[vortexVisé][1]] = 0,pion
		vortexSelected(vortexVisé)
	# Action pour chaque déplacement
	if (deplacement != None or touche != None) and choisirVortex == False:
		for yAxes in range(nbCasesY):
			for xAxes in range(nbCasesX):
				if Plateau[yAxes][xAxes] == pion and dejaVu == False:
					disponnible = False

					if deplacement == 'Left' :
						if not (yAxes,xAxes-1) in posMurV :				# Si case visée != mur vertical
							decalageY, decalageX, autorisationMurH, autorisationMurV = 0, -1, True, False
							if xAxes > 0: disponnible = True							
					if deplacement == 'Right' : 
						if not (yAxes,xAxes) in posMurV :				# Si case visée != mur vertical
							decalageY, decalageX, autorisationMurH, autorisationMurV = 0, 1, True, True
							if xAxes < nbCasesX-1: disponnible = True
					if deplacement == 'Up' :
						if not (yAxes,xAxes) in posMurH :				# Si case visée != mur horizontal
							decalageY, decalageX, autorisationMurV = -1, 0, True
							if yAxes > 0: disponnible = True
					if deplacement == 'Down' :
						if not (yAxes+1,xAxes) in posMurH :				# Si case visée != mur horizontal
							decalageY, decalageX, autorisationMurV = 1, 0, True
							if yAxes < nbCasesY-1: disponnible = True

					if deplacement == 'Escalators' :
						if Plateau[yAxes][xAxes] == pion and (yAxes,xAxes) in posEscalator:
							for i in range(len(posEscalator)):
								if i%2 == 0: esca = +1
								if i%2 != 0: esca = -1
								if (yAxes,xAxes) == (posEscalator[i][0],posEscalator[i][1]):
									Plateau[yAxes][xAxes],Plateau[posEscalator[i+esca][0]][posEscalator[i+esca][1]] = 0,pion
						dejaVu = True
					if deplacement == 'Vortex' and not sortieOn:
						if len(dico_VorPion[pion])!=0:
							choisirVortex = True
							dejaVu = True
					if deplacement == 'Exploration' :
						if (yAxes,xAxes) not in explorationsVues:
							if Plateau[yAxes][xAxes] == pion and (yAxes,xAxes) in dico_ExploPion.get(pion):

								if Plateau[yAxes-1][xAxes] == None:							# Ajout en haut
									if yAxes-4 >= 0:
										while valide == False :
											n_to_add = (randint(0,len(tuiles_to_add_H)-1))
											if n_to_add not in tuilesUsed :
												tuilesUsed.append(n_to_add)
												break
										to_add = tuiles_to_add_H[n_to_add]
										for n in range(len(to_add)): Plateau[yAxes-n-1][xAxes-1:xAxes+2] = to_add[3-n]
										listeMurH, listeMurV = getMurs('tuilesH.txt',n_to_add,mursH,mursV,yAxes-4,xAxes-1)
										posExploration_War, posExploration_Wiz, posExploration_Elf, posExploration_Dwa = getExploration('tuilesH.txt',n_to_add,exploWar,exploWiz,exploElf,exploDwa,yAxes-4,xAxes-1)
										posVortex_War, posVortex_Wiz, posVortex_Elf, posVortex_Dwa = getVortex('tuilesH.txt',n_to_add,vortexWar,vortexWiz,vortexElf,vortexDwa,yAxes-4,xAxes-1)
										posEscalator = getEscalator('tuilesH.txt',n_to_add,escalators,yAxes-4,xAxes-1)
										del Plateau[yAxes-1][xAxes+3]
										del Plateau[yAxes-2][xAxes+3]
										del Plateau[yAxes-3][xAxes+3]
										del Plateau[yAxes-4][xAxes+3]
										ajouté, valide = True, False

								if Plateau[yAxes][xAxes-1] == None:							# Ajout à gauche
									if xAxes-4 >= 0:
										while valide == False :
											n_to_add = (randint(0,len(tuiles_to_add_G)-1))
											if n_to_add not in tuilesUsed :
												tuilesUsed.append(n_to_add)
												break
										to_add = tuiles_to_add_G[n_to_add]
										for n in range(len(to_add)): Plateau[yAxes-n+1][xAxes-4:xAxes] = to_add[3-n]
										listeMurH, listeMurV = getMurs('tuilesG.txt',n_to_add,mursH,mursV,yAxes-2,xAxes-4)
										posExploration_War, posExploration_Wiz, posExploration_Elf, posExploration_Dwa = getExploration('tuilesG.txt',n_to_add,exploWar,exploWiz,exploElf,exploDwa,yAxes-2,xAxes-4)
										posVortex_War, posVortex_Wiz, posVortex_Elf, posVortex_Dwa = getVortex('tuilesG.txt',n_to_add,vortexWar,vortexWiz,vortexElf,vortexDwa,yAxes-2,xAxes-4)
										posEscalator = getEscalator('tuilesG.txt',n_to_add,escalators,yAxes-2,xAxes-4)
										ajouté = True

								if Plateau[yAxes][xAxes+1] == None:							# Ajout à droite
									if xAxes+4 <= nbCasesX:
										while valide == False :
											n_to_add = (randint(0,len(tuiles_to_add_D)-1))
											if n_to_add not in tuilesUsed :
												tuilesUsed.append(n_to_add)
												break
										to_add = tuiles_to_add_D[n_to_add]
										for n in range(len(to_add)): Plateau[yAxes+n-1][xAxes+1:xAxes+4] = to_add[n]
										listeMurH, listeMurV = getMurs('tuilesD.txt',n_to_add,mursH,mursV,yAxes-1,xAxes+1)
										posExploration_War, posExploration_Wiz, posExploration_Elf, posExploration_Dwa = getExploration('tuilesD.txt',n_to_add,exploWar,exploWiz,exploElf,exploDwa,yAxes-1,xAxes+1)
										posVortex_War, posVortex_Wiz, posVortex_Elf, posVortex_Dwa = getVortex('tuilesD.txt',n_to_add,vortexWar,vortexWiz,vortexElf,vortexDwa,yAxes-1,xAxes+1)
										posEscalator = getEscalator('tuilesD.txt',n_to_add,escalators,yAxes-1,xAxes+1)
										ajouté = True

								if Plateau[yAxes+1][xAxes] == None:							# Ajout en bas
									if yAxes+4 <= nbCasesY:
										while valide == False :
											n_to_add = (randint(0,len(tuiles_to_add_B)-1))
											if n_to_add not in tuilesUsed :
												tuilesUsed.append(n_to_add)
												break
										to_add = tuiles_to_add_B[n_to_add]
										for n in range(len(to_add)): Plateau[yAxes+n+1][xAxes-2:xAxes+2] = to_add[n]
										listeMurH, listeMurV = getMurs('tuilesB.txt',n_to_add,mursH,mursV,yAxes+1,xAxes-2)
										posExploration_War, posExploration_Wiz, posExploration_Elf, posExploration_Dwa = getExploration('tuilesB.txt',n_to_add,exploWar,exploWiz,exploElf,exploDwa,yAxes+1,xAxes-2)
										posVortex_War, posVortex_Wiz, posVortex_Elf, posVortex_Dwa = getVortex('tuilesB.txt',n_to_add,vortexWar,vortexWiz,vortexElf,vortexDwa,yAxes+1,xAxes-2)
										posEscalator = getEscalator('tuilesB.txt',n_to_add,escalators,yAxes+1,xAxes-2)
										ajouté = True

								if ajouté == True :											# Actualisation des variables
									explorationsVues.append((yAxes,xAxes))
									vortexWar, vortexWiz, vortexElf, vortexDwa = posVortex_War, posVortex_Wiz, posVortex_Elf, posVortex_Dwa
									exploWar, exploWiz, exploElf, exploDwa = posExploration_War, posExploration_Wiz, posExploration_Elf, posExploration_Dwa
									mursH, mursV = listeMurH, listeMurV
									escalators = posEscalator

					if disponnible == True:
						dejaVu = True
						if Plateau[yAxes+decalageY][xAxes+decalageX] == 0 :				# Si case visée = vide
							if onIndiceExplo == True :
								Plateau[yAxes+decalageY][xAxes+decalageX], Plateau[yAxes][xAxes] = pion, 10
								onIndiceExplo = False
								break
							Plateau[yAxes+decalageY][xAxes+decalageX], Plateau[yAxes][xAxes] = pion, 0
							break
						if Plateau[yAxes+decalageY][xAxes+decalageX] == 6 :				# Si case visée = sortie active
							Plateau[yAxes][xAxes] = 0
							pionsInSortie += 1
							break
						if Plateau[yAxes+decalageY][xAxes+decalageX] == 8 :				# Si case visée = sablier
								Plateau[yAxes+decalageY][xAxes+decalageX], Plateau[yAxes][xAxes] = pion, 0
								reverseTimer = not reverseTimer
								a = secElapsed
								secElapsed = 0
								break
						if Plateau[yAxes+decalageY][xAxes+decalageX] == 10 :			# Si case visée = exploration
							Plateau[yAxes+decalageY][xAxes+decalageX], Plateau[yAxes][xAxes] = pion, 0
							onIndiceExplo = True
							break
						if Plateau[yAxes+decalageY][xAxes+decalageX] == pion+10 :		# Si case visée = son objet
							Plateau[yAxes+decalageY][xAxes+decalageX], Plateau[yAxes][xAxes] = pion, 0
							break

	return debug, choisirVortex, onIndiceExplo, mursH, mursV, exploWar, exploWiz, exploElf, exploDwa, vortexWar, vortexWiz, vortexElf, vortexDwa, escalators

# ---------- Partie visuelle ---------- #

def affichage() :
	"""
		Affiche le contenu à afficher en fonction de variables et d'éléments du Plateau.
	"""
	x, y, n = 0, 0, 0
	if touche != None:
		image(0, 0, 'nuages.gif', ancrage = 'nw', tag = 'nuages')
		for yAxes in range(nbCasesY):
			locY = yAxes*largeur-largeur/2+largeur
			for xAxes in range(nbCasesX):
				locX = xAxes*largeur-largeur/2+largeur
				## Affiche un carré gris sur chaque case ##
				rectangle(x, y, x+largeur, y+largeur, remplissage = 'light grey', tag='case'+str(n))
				## N'affiche rien pour les cases None ##
				if Plateau[yAxes][xAxes] == None : efface('case'+str(n))
				## Affiche un indice en face de l'exploration ##
				if Plateau[yAxes][xAxes] == 10: image(locX, locY, 'exploration_indice.gif', ancrage = 'center', tag = 'indiceExplo')
				## Affiche les exploration  ##
				if Plateau[yAxes][xAxes] != None:
					if (yAxes,xAxes) in posExploration_War : image(locX+1, locY, 'exploration_War.gif', ancrage = 'center', tag = 'exploWar')
					if (yAxes,xAxes) in posExploration_Wiz : image(locX+1, locY, 'exploration_Wiz.gif', ancrage = 'center', tag = 'exploWiz')
					if (yAxes,xAxes) in posExploration_Elf : image(locX+1, locY, 'exploration_Elf.gif', ancrage = 'center', tag = 'exploElf')
					if (yAxes,xAxes) in posExploration_Dwa : image(locX+1, locY, 'exploration_Dwa.gif', ancrage = 'center', tag = 'exploDwa')
				## Affiche les vortex ##
				if not sortieOn:
					dico_VorPion = {1:posVortex_War, 2:posVortex_Wiz, 3:posVortex_Elf, 4:posVortex_Dwa}
					for i in dico_VorPion:
						for j in dico_VorPion.get(i):
							if i == 1:
								if yAxes == j[0] and xAxes == j[1]: image(locX+1, locY, 'VortexR.gif', ancrage = 'center', tag = 'vortex')
							if i == 2:
								if yAxes == j[0] and xAxes == j[1]: image(locX+1, locY, 'VortexB.gif', ancrage = 'center', tag = 'vortex')
							if i == 3:
								if yAxes == j[0] and xAxes == j[1]: image(locX+1, locY, 'VortexV.gif', ancrage = 'center', tag = 'vortex')
							if i == 4:
								if yAxes == j[0] and xAxes == j[1]: image(locX+1, locY, 'VortexJ.gif', ancrage = 'center', tag = 'vortex')
				## Affiche les escalators ##
					for k in range(len(posEscalator)):
						if yAxes == posEscalator[k][0] and xAxes == posEscalator[k][1]: image(locX+1, locY, 'Escalator_transp.gif', ancrage = 'center', tag = 'escalator')
				## Affiche les pions ##
				if Plateau[yAxes][xAxes] == 1 : image(locX, locY, 'Warrior_pion_transp.gif', ancrage = 'center', tag = 'warrior')
				if Plateau[yAxes][xAxes] == 2 : image(locX, locY, 'Wizzard_pion_transp.gif', ancrage = 'center', tag = 'wizzard')
				if Plateau[yAxes][xAxes] == 3 : image(locX, locY, 'Elf_pion_transp.gif', ancrage = 'center', tag = 'elf')
				if Plateau[yAxes][xAxes] == 4 : image(locX, locY, 'Dwarf_pion_transp.gif', ancrage = 'center', tag = 'dwarf')
				## Affiche sortie on ou off ##
				if Plateau[yAxes][xAxes] == 5 : image(locX+1, locY, 'sortie_off.gif', ancrage = 'center', tag = 'exitOff')
				if Plateau[yAxes][xAxes] == 6 : image(locX+1, locY, 'sortie_on.gif', ancrage = 'center', tag = 'exitOn')
				## Affiche les cases vides ##
				if Plateau[yAxes][xAxes] == 7 : image(locX+1, locY, 'mur.gif', ancrage = 'center', tag = 'mur')
				## Affiche les sabliers ##
				if Plateau[yAxes][xAxes] == 8 : image(locX+1, locY, 'sablierReverse.gif', ancrage = 'center', tag = 'sablierReverse')
				## Affiche les murs horizontaux ##
				if (yAxes,xAxes) in posMurH: rectangle(xAxes*largeur, yAxes*largeur-3, xAxes*largeur+largeur, yAxes*largeur+3, remplissage = 'black', tag = 'murHorizontal')
				## Affiche les murs verticaux ##
				if (yAxes,xAxes-1) in posMurV: rectangle(xAxes*largeur-3, yAxes*largeur, xAxes*largeur+3, yAxes*largeur+largeur, remplissage = 'black', tag = 'murVertical')
				## Affiche les objets tant que la sortie n'est pas active ##
				if not sortieOn:
					if yAxes == posObjets[0][0] and xAxes == posObjets[0][1]: image(locX, locY, 'Warrior_objet_transp.gif', ancrage = 'center', tag = 'warriorObj')
					if yAxes == posObjets[1][0] and xAxes == posObjets[1][1]: image(locX, locY, 'Wizzard_objet_transp.gif', ancrage = 'center', tag = 'wizzardObj')
					if yAxes == posObjets[2][0] and xAxes == posObjets[2][1]: image(locX, locY, 'Elf_objet_transp.gif', ancrage = 'center', tag = 'elfObj')
					if yAxes == posObjets[3][0] and xAxes == posObjets[3][1]: image(locX, locY, 'Dwarf_objet_transp.gif', ancrage = 'center', tag = 'dwarfObj')
				x += largeur
				n += 1
			x,y = 0,y+largeur

def pionsDroite():
	"""
	Affiche les icônes de pions et leur objet sur le côté, ainsi qu'un rond indiquant quel pion est séléctionné.
	"""
	texte(nbCasesX*largeur +175, largeur*0.5, 'Pion séléctionné :',taille = 22, ancrage = 'center')
	#Affiche les icônes propres à chaque pion
	vuWar, vuWiz, vuElf, vuDwa = False, False, False, False
	for yAxes in range(nbCasesY):
		for xAxes in range(nbCasesX):
			if Plateau[yAxes][xAxes] == 1: vuWar = True
			if Plateau[yAxes][xAxes] == 2: vuWiz = True
			if Plateau[yAxes][xAxes] == 3: vuElf = True
			if Plateau[yAxes][xAxes] == 4: vuDwa = True

	if vuWar: image(nbCasesX*largeur +125, largeur*1.5, 'Warrior_pion_transp.gif', ancrage = 'center')
	if not vuWar: image(nbCasesX*largeur +125, largeur*1.5, 'Warrior_pion_transp_nb.gif', ancrage = 'center')
	texte(nbCasesX*largeur +175, largeur*1.5, '→', taille = '30', ancrage = 'center')
	image(nbCasesX*largeur +225, largeur*1.5, 'Warrior_objet_transp.gif', ancrage = 'center')

	if vuWiz: image(nbCasesX*largeur +125, largeur*2.5, 'Wizzard_pion_transp.gif', ancrage = 'center')
	if not vuWiz: image(nbCasesX*largeur +125, largeur*2.5, 'Wizzard_pion_transp_nb.gif', ancrage = 'center')
	texte(nbCasesX*largeur +175, largeur*2.5, '→', taille = '30', ancrage = 'center')
	image(nbCasesX*largeur +225, largeur*2.5, 'Wizzard_objet_transp.gif', ancrage = 'center')

	if vuElf: image(nbCasesX*largeur +125, largeur*3.5, 'Elf_pion_transp.gif', ancrage = 'center')
	if not vuElf: image(nbCasesX*largeur +125, largeur*3.5, 'Elf_pion_transp_nb.gif', ancrage = 'center')
	texte(nbCasesX*largeur +175, largeur*3.5, '→', taille = '30', ancrage = 'center')
	image(nbCasesX*largeur +225, largeur*3.5, 'Elf_objet_transp.gif', ancrage = 'center')

	if vuDwa: image(nbCasesX*largeur +125, largeur*4.5 -6, 'Dwarf_pion_transp.gif', ancrage = 'center')
	if not vuDwa: image(nbCasesX*largeur +125, largeur*4.5 -6, 'Dwarf_pion_transp_nb.gif', ancrage = 'center')
	texte(nbCasesX*largeur +175, largeur*4.5, '→', taille = '30', ancrage = 'center')
	image(nbCasesX*largeur +225, largeur*4.5, 'Dwarf_objet_transp.gif', ancrage = 'center')

def pionSelected(pion):
	"""
	Affiche un rond autour dsu pion séléctionné.
	"""
	efface('selecPion')
	cercle(nbCasesX*largeur +125, largeur*1.5 +(pion-1)*largeur, 25, epaisseur = 2, couleur = 'purple', tag = 'selecPion')

def actionSelectedJ1(i):
	"""
	Affiche un rond autour de l'action séléctionnée pour le Joueur 1.
	"""
	efface('selecActionJ1')
	cercle(nbCasesX*largeur +20 +(i-1)*50, largeur*6.5, 25, epaisseur = 2, couleur = 'red', tag = 'selecActionJ1')

def actionSelectedJ2(i):
	"""
	Affiche un rond autour de l'action séléctionnée pour le Joueur 1.
	"""
	efface('selecActionJ2')
	cercle(nbCasesX*largeur +20 +(i-1)*50, largeur*8.5, 25, epaisseur = 2, couleur = 'blue', tag = 'selecActionJ2')

def actionSelectedJ3(i):
	"""
	Affiche un rond autour de l'action séléctionnée pour le Joueur 3.
	"""
	efface('selecActionJ3')
	cercle(nbCasesX*largeur +20 +(i-1)*50, largeur*10.5, 25, epaisseur = 2, couleur = 'orange', tag = 'selecActionJ3')

def vortexSelected(i):
	"""
	Affiche les contours du vortex séléctionné.
	"""
	efface('selecVortex')
	dico_VorPion = {1:posVortex_War, 2:posVortex_Wiz, 3:posVortex_Elf, 4:posVortex_Dwa}
	Vortex_pion = dico_VorPion.get(pionVisé)
	rectangle(largeur*Vortex_pion[vortexVisé][1],largeur*Vortex_pion[vortexVisé][0],largeur*Vortex_pion[vortexVisé][1]+largeur,largeur*Vortex_pion[vortexVisé][0]+largeur, couleur='red', epaisseur=3, tag = 'selecVortex')

def actionSelection():
	"""
	Affiche un cercle de couleur, suivi du joueur qui contrôle cette couleur ainsi que les commandes pour déplacer son pion
	"""
	efface('imgActions')
	actions_img = {'Left' : 'direction_gauche.gif', 'Up' : 'direction_haut.gif', 'Down' : 'direction_bas.gif', 'Right' : 'direction_droite.gif',
	'Vortex' : 'Vortex.gif', 'Escalators' : 'Escalator_transp.gif', 'Exploration' : 'loupe.gif'}
	
	pionSelected(pionVisé)
	## Actions J1 ##
	if nbrJoueurs == '1 joueur' or nbrJoueurs == '2 joueurs' or nbrJoueurs == '3 joueurs':
		actionSelectedJ1(actionViséeJ1)
		texte(nbCasesX*largeur +175, largeur*5.5, 'Actions J1', couleur ='red', taille = 18, ancrage = 'center')
		n=1
		for i in actionsJ1:
			image(nbCasesX*largeur-30 +n*50, largeur*6.5, str(actions_img.get(i)), ancrage = 'center', tag = 'imgActions')
			n+=1
	## Actions J2 ##
	if nbrJoueurs == '2 joueurs' or nbrJoueurs == '3 joueurs':
		actionSelectedJ2(actionViséeJ2)
		texte(nbCasesX*largeur +175, largeur*7.5, 'Actions J2', couleur ='blue', taille = 18, ancrage = 'center')
		n=1
		for i in actionsJ2:
			image(nbCasesX*largeur-30 +n*50, largeur*8.5, str(actions_img.get(i)), ancrage = 'center', tag = 'imgActions')
			n+=1
	## Actions J3 ##
	if nbrJoueurs == '3 joueurs':
		actionSelectedJ3(actionViséeJ3)
		texte(nbCasesX*largeur +175, largeur*9.5, 'Actions J3', couleur ='orange', taille = 18, ancrage = 'center')
		n=1
		for i in actionsJ3:
			image(nbCasesX*largeur-30 +n*50, largeur*10.5, str(actions_img.get(i)), ancrage = 'center', tag = 'imgActions')
			n+=1

def objectif(sortie):
	"""
	Affiche en bas à droite les objets restants à vole.
	"""
	# Affiche les objets manquants tant que la sortie n'est pas active
	texte(nbCasesX*largeur +175, (nbCasesY*largeur)/2 + 5*largeur, 'Objectif actuel :', taille = 22, ancrage = 'center')
	if not sortie:
		image(nbCasesX*largeur +75, (nbCasesY*largeur)/2 + 6.25*largeur, 'Warrior_objet_transp.gif', ancrage = 'center', tag= 'WarriorObjetPrit')
		image(nbCasesX*largeur +135, (nbCasesY*largeur)/2 + 6.25*largeur, 'Wizzard_objet_transp.gif', ancrage = 'center', tag= 'WizzardObjetPrit')
		image(nbCasesX*largeur +195, (nbCasesY*largeur)/2 + 6.25*largeur, 'Elf_objet_transp.gif', ancrage = 'center', tag= 'ElfObjetPrit')
		image(nbCasesX*largeur +255, (nbCasesY*largeur)/2 + 6.25*largeur, 'Dwarf_objet_transp.gif', ancrage = 'center', tag= 'DwarfObjetPrit')
	if sortie: image(nbCasesX*largeur +165, (nbCasesY*largeur)/2 + 6.25*largeur, 'sortie_on.gif', ancrage = 'center', tag= 'SortieOn')
	# Efface l'objet en bas à droite si le pion est dessus
	for yAxes in range(nbCasesY):
		for xAxes in range(nbCasesX):
			if Plateau[yAxes][xAxes] == 1:
				if yAxes == posObjets[0][0] and xAxes == posObjets[0][1]: efface('WarriorObjetPrit')
			if Plateau[yAxes][xAxes] == 2:
				if yAxes == posObjets[1][0] and xAxes == posObjets[1][1]: efface('WizzardObjetPrit')
			if Plateau[yAxes][xAxes] == 3:
				if yAxes == posObjets[2][0] and xAxes == posObjets[2][1]: efface('ElfObjetPrit')
			if Plateau[yAxes][xAxes] == 4:
				if yAxes == posObjets[3][0] and xAxes == posObjets[3][1]: efface('DwarfObjetPrit')
					
def timer(seconde, startTime, etatReverse) :
	"""
	Affiche un timer décroissant en secondes, depuis le nombre rentré en paramètre.
	"""
	global minutes, secondes, secElapsed
	couleur = 'dark green'
	if etatReverse == False:
		secElapsed = int((time.time() - (startTime+a*2) )) 	# Secondes écoulées depuis le début du programme
		secLeft = seconde - secElapsed						# Secondes restantes
	if etatReverse == True:
		secElapsed = int((time.time() - (startTime+a) ))
		secLeft = a - secElapsed
	# Conversion du temps en minutes:secondes
	minutes = secLeft // 60
	secondes = secLeft - minutes*60
	if minutes < 0:	perdu()									# Si le temps tombe à 0, partie perdue.
	if minutes == 0 and secondes < 30: couleur = 'red'		# Si - de 30sec restantes : couleur rouge
	#Affichage du temps restant en secondes
	efface('timer')
	texte(largeur//2, nbCasesY*largeur+37.5, "Temps restant: " + str(minutes) + "min" + str(secondes), couleur=couleur, taille = 20, tag = "timer", ancrage = 'w')

def instructions():
	"""
	Affiche sous forme de texte les actions que le joueur peut faire
	"""
	efface('commandes')
	efface('selectorInstructions')
	efface('quitterInstructions')
	efface('movePionInstructions')
	efface('debugModeInstructions')
	efface('Tableau')
	texte(largeur*6 +longueur_texte(minutes+secondes)+longueur_texte('min')-10, nbCasesY*largeur+12, "Commandes:", couleur='black', taille = 14, ancrage = 'w', tag = 'commandes')
	texte(largeur*6 +longueur_texte(minutes+secondes)+longueur_texte('min') +27.5, nbCasesY*largeur+30, "F1 : Quitter le jeu", couleur='black', taille = 12, ancrage = 'w', tag = 'selectorInstructions')
	texte(largeur*6 +longueur_texte(minutes+secondes)+longueur_texte('min') +37.5, nbCasesY*largeur+50, "F2 : Débug mode (on/off)", couleur='black', taille = 12, ancrage = 'w', tag = 'movePionInstructions')
	image(largeur*6 +longueur_texte(minutes+secondes)+longueur_texte('min') +500, nbCasesY*largeur+40, 'Tableau_cmdJ.gif', ancrage = 'w', tag= 'Tableau')
	texte(largeur*6 +220 +longueur_texte(minutes+secondes)+longueur_texte('min') +27.5, nbCasesY*largeur+30, "F3 : Sauvegarder", couleur='black', taille = 12, ancrage = 'w', tag = 'quitterInstructions')
	texte(largeur*6 +220 +longueur_texte(minutes+secondes)+longueur_texte('min') +27.5, nbCasesY*largeur+50, "e : Changer de pion à déplacer", couleur='black', taille = 12, ancrage = 'w', tag = 'debugModeInstructions')

def affichageDroit():
	if touche != None :
		pionsDroite()
		actionSelection()
		ligne(nbCasesX*largeur,0,nbCasesX*largeur,nbCasesY*largeur, epaisseur=3)
		ligne(nbCasesX*largeur +7, (nbCasesY*largeur)/2 + 5.5*largeur, nbCasesX*largeur +343, (nbCasesY*largeur)/2 + 5.5*largeur, couleur='black', epaisseur=3)
		objectif(sortieOn)

def affichageBas():
	efface('separationBas')
	timer(180, startTime, reverseTimer)
	ligne(0,nbCasesY*largeur,nbCasesX*largeur,nbCasesY*largeur, epaisseur=2)
	ligne(largeur*5.3+longueur_texte(minutes+secondes)+longueur_texte('min'), nbCasesY*largeur+12, largeur*5.3+longueur_texte(minutes+secondes)+longueur_texte('min'), nbCasesY*largeur+65, couleur='black', epaisseur=3, tag = 'separationBas')
	instructions()

def perdu():
	"""
	Si tous les pions ne sont pas sortis avant la fin du temps impartit, la partie est perdue.
	"""
	efface_tout()
	while 1 :
		texte(largeur*nbCasesX/2+180, largeur*6, "Temps écoulé, perdu..", couleur="red", ancrage = "n", taille = 45)
		texte(largeur*nbCasesX/2+180, largeur*9, "Vous ferez mieux la prochaine fois, retentez votre chance!", couleur="black", ancrage = "center", taille = 25)
		attente_clic()
		break
	ferme_fenetre()

def gagner():
	"""
	Si tous les pions sont sortis, la prtie est gagnée.
	"""
	efface_tout()
	secElapsed = int((time.time() - (startTime+a*2) )) 	# Secondes écoulées depuis le début du programme
	# Conversion du temps en minutes:secondes
	while 1 :
		texte(largeur*nbCasesX/2+180, largeur*6, "Vous avez gagné!", couleur="dark green", ancrage = "center", taille = 45)
		texte(largeur*nbCasesX/2+180, largeur*9, "Félicitations, vous avez finit le jeu en " + '1' + "min" + '52', couleur="black", ancrage = "center", taille = 25)
		attente_clic()
		break	
	ferme_fenetre()

# ----------------------- Main Program --------------------------- #
if __name__ == '__main__':
	creationMap(20,14)

	## Création entités ##
	directions = ['Left', 'Right', 'Up', 'Down']
	special = ['Vortex', 'Escalators', 'Exploration']
	sortieOn, choixVortex = False, False
	pionsInSortie = 0
	posExploration_War, posVortex_War, posObjWar = [(5,11)],  [(7,9)],  (99,99)
	posExploration_Wiz, posVortex_Wiz, posObjWiz = [(7,12)],  [(8,9)],  (99,99)
	posExploration_Elf, posVortex_Elf, posObjElf = [(6,9)],  [(5,12)],  (99,99)
	posExploration_Dwa, posVortex_Dwa, posObjDwa = [(8,10)],   [(6,12)],  (99,99)
	posObjets = [(99,99),(99,99),(99,99),(99,99)] 
	posEscalator = [(8,11),(7,12)]
	posMurH = [(5,9),(5,10),(5,12),(6,9),(6,12),(7,9),(7,12),(8,9),(8,12),(9,9),(9,11),(9,12)]
	posMurV = [(5,8),(7,8),(7,11),(8,8),(5,12),(6,12),(8,12)]
	Plateau = [ [None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,8,0,0,0,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,0,1,2,0,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,0,3,4,0,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,0,0,0,7,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None],
				[None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None,None] ]
	## Menu ##
	affichageMenu()
	if nbrJoueurs == '1 joueur': actions1J()
	if nbrJoueurs == '2 joueurs': actions2J()
	if nbrJoueurs == '3 joueurs': actions3J()

	## Initialisations variables ##
	tuiles_to_add_G = getTuiles('tuilesG.txt')		# Récupération des tuiles dans le fichier texte
	tuiles_to_add_H = getTuiles('tuilesH.txt')		# Récupération des tuiles dans le fichier texte
	tuiles_to_add_D = getTuiles('tuilesD.txt')		# Récupération des tuiles dans le fichier texte
	tuiles_to_add_B = getTuiles('tuilesB.txt')		# Récupération des tuiles dans le fichier texte
	if choix != 'Continuer': startTime = time.time()			# Initialisation du temps
	explorationsVues, tuilesUsed = list(), list()
	pionVisé, actionViséeJ1, actionViséeJ2, actionViséeJ3, vortexVisé = 1, 1, 1, 1, 0
	debugMode, reverseTimer, surIndiceExplo = False, False, False
	objetsOwn = 0
	a = 0
	efface_tout()
	## Boucle principale ##
	while 1:
		affichageBas()
		affichageDroit()		
		affichage()
		posObjets,posObjWar,posObjWiz,posObjElf,posObjDwa = getPosObjet(posObjets,posObjWar,posObjWiz,posObjElf,posObjDwa)
		debugMode,choixVortex,surIndiceExplo,posMurH,posMurV,posExploration_War,posExploration_Wiz,posExploration_Elf,posExploration_Dwa,posVortex_War,posVortex_Wiz,posVortex_Elf,posVortex_Dwa,posEscalator = actionTouche(pionVisé, actionViséeJ1, actionViséeJ2, actionViséeJ3, choixVortex, surIndiceExplo, objetsOwn, pionsInSortie, debugMode,posMurH,posMurV,posExploration_War,posExploration_Wiz,posExploration_Elf,posExploration_Dwa,posVortex_War,posVortex_Wiz,posVortex_Elf,posVortex_Dwa,posEscalator)
		isWin(pionsInSortie)
		sortieOn = isSortieOn(sortieOn)
		mise_a_jour()
		if touche != None :
			efface_tout()